/*
  
iCustom(
   NULL,0,"AsimmetricStochNR",  //   -  
   KperiodShort,              //  () %K
   KperiodLong,               //  () %K
   Dperiod,                   // %D 
   Slowing,                   // 
   Dmethod,                   //  MA : 0-SMA, 1-EMA
   PriceField,                //  : 0-High/Low; 1-Close/Close
   Sens,                      //   .
   OverSold,                  //    %%
   N,                         // : 0- , 1- , 2- 
   i                          // 
  );
*/

#property indicator_separate_window //  .  
#property indicator_buffers 3
#property indicator_color1 Blue // 
#property indicator_style1 0
#property indicator_color2 Red // 
#property indicator_style2 0
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level3 50

//  
extern int KperiodShort=5; // %K
extern int KperiodLong=12; // %K
extern int Dperiod=1; // %D 
   double kd; // . EMA  
extern int Slowing=3; // 
extern int Dmethod=0; //  MA : 0-SMA, 1-EMA
extern int PriceField=0; //  : 0-High/Low; 1-Close/Close
extern int Sens=7; //   .
   double sens; //   
extern int OverSold=20; //    %%
   int OverBought;
 int History=0; //  : 0 -  

//  .
double   Main[], // 
         Signal[], // 
         Trend[]; // : 0 - , 1 - 

int init() {
   sens=Sens*Point; //   
   if(Dmethod==1) kd=2.0/(1+Dperiod); // . EMA  
   
   SetLevelValue(0,OverSold);
   OverBought=100-OverSold;
   SetLevelValue(1,OverBought);
   

   //     
   SetIndexBuffer(0,Main);
   SetIndexStyle(0,DRAW_LINE);
   string _str="("+KperiodShort+"/"+KperiodLong+","+Slowing+")";
   SetIndexLabel(0,"Main"+_str);
   SetIndexEmptyValue(0,0.0);
   //  
   SetIndexBuffer(1,Signal);
   SetIndexStyle(1,DRAW_LINE);
   _str="("+Dperiod+")";
   SetIndexLabel(1,"Signal"+_str);
   SetIndexEmptyValue(0,0.0);
   // 
   SetIndexBuffer(2,Trend);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexLabel(2,"Trend");
   SetIndexEmptyValue(0,0.0);

   //  
   if(Sens!=0) string ShName=Sens+" ";
   ShName=ShName+"Stoch ";
   if(PriceField==0) ShName=ShName+"H/L";
   else ShName=ShName+"C/C";
   ShName=ShName+" ("+KperiodShort+"/"+KperiodLong+","+Dperiod+","+Slowing+")";
   IndicatorShortName(ShName);   
   
  }

int reinit() // -  
  {
   ArrayInitialize(Main,0.0);
   ArrayInitialize(Signal,0.0);
   ArrayInitialize(Trend,0.0);
   return(0);
  }

void start() {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit(); 
   int limit=Bars-ic-1; // - 
   
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   limit = Bars - counted_bars;
   if(counted_bars==0) limit-=1+1;   
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      //  
      static bool Kperiod0,Kperiod1,trend;
      if(i==limit && limit>1) { 
         Kperiod0=KperiodShort;
         Kperiod1=KperiodShort;
         trend=0;
        }
      // 
      Main[i]=Stoch(Kperiod0, Kperiod1, Slowing, PriceField, sens, i);
      // 
      switch(Dmethod) {
         case 1: // EMA
            Signal[i]=kd*Main[i]+(1-kd)*Signal[i+1]; break;
         case 0: // SMA
            int sh=i+Dperiod;
            double ma=Signal[i+1]*Dperiod-Main[sh];
            Signal[i]=(ma+Main[i])/Dperiod;
        }
      //  
      if(Signal[i+1]>OverBought) { // 
         Kperiod0=KperiodShort;
         Kperiod1=KperiodLong;
         trend=1;
        }
      if(Signal[i+1]<OverSold) { // 
         Kperiod0=KperiodLong;
         Kperiod1=KperiodShort;
         trend=0;
        }
      Trend[i]=trend;
     }
  }
//>>>>>>>>>>>>>>>>>>>>>  

//   
double Stoch(int Kperiod0, int Kperiod1, int Slowing, int PriceField, double sens, int i) {  
   if(i+MathMax(Kperiod0,Kperiod1)+Slowing>Bars) return(-1); //   - 
   //     /
   double max,min,c;
   for(int j=i; j<i+Slowing; j++) {
      if(PriceField==1) { //  Close
         max+=Close[ArrayMaximum(Close,Kperiod0,j)];
         min+=Close[ArrayMinimum(Close,Kperiod1,j)];
        }
      else { //  High/Low
         max+=High[ArrayMaximum(High,Kperiod0,j)];
         min+=Low[ArrayMinimum(Low,Kperiod1,j)];
        }
      c+=Close[j];
     }
   // 
   sens*=Slowing; //       
   double delta=max-min; // 
   double diff=sens-delta; //    .  
   if(diff>0) { //   >0 (  ), 
      delta=sens; //  = ,
      min-=diff/2; //   
     }
   //  
   if(delta==0) return(-2); //   
   else return(100*(c-min)/delta); // 
  }


